﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI.WebControls;
using System.IO;

namespace KnockoutServerSideViewModel.Web
{
    
    public class BaseKOUserControl : System.Web.UI.UserControl
    {
        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
        }

        private BaseViewModel _ViewModel;
        public BaseViewModel ViewModel
        {
            get
            {
                return _ViewModel;
            }
            set
            {
                _ViewModel = value;
                _ViewModel.ModelClass = string.Format("{0}.{1}, {2}", _ViewModel.GetType().Namespace, _ViewModel.GetType().Name, _ViewModel.GetType().Assembly.GetName().FullName);
            }
        }

      private string _ControlName;
        protected string ControlName
        {
            get {
                if (string.IsNullOrEmpty(_ControlName))
                {
                    return this.GetType().BaseType.Name;
                }
                else
                {
                    return _ControlName;
                }
            }
            set {
                _ControlName = value;
            }
        }

        protected override void Render(System.Web.UI.HtmlTextWriter writer)
        {
            writer.WriteLine(string.Format("<span id=\"sp{0}\">", this.ClientID));
            base.Render(writer);
            writer.WriteLine(string.Format("</span>"));
            writer.WriteLine(string.Format("<script type=\"text/javascript\">\n$().ready(function () {{ var model = setModelFunction(\"{0}\", \"{1}\"); model.init(); ko.applyBindings(model.viewModel, document.getElementById(\"sp{0}\")); }});\n</script>", this.ClientID, this.ControlName));
            writer.WriteLine(string.Format("<input type=\"hidden\" id = \"hd{0}\" value=\"{1}\" />", this.ClientID, HttpUtility.HtmlEncode(Utilities.ConvertToJson(ViewModel))));
        }
    }
}