﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Reflection;
using System.IO;

namespace KnockoutServerSideViewModel.Web
{
    public class Utilities
    {
        /// <summary>
        /// converts the supplied model to a json string
        /// </summary>
        /// <param name="model"></param>
        /// <returns></returns>
        public static string ConvertToJson(object model)
        {
            var serializer = new System.Web.Script.Serialization.JavaScriptSerializer();
            return serializer.Serialize(model);
        }

        /// <summary>
        /// converts the supplied json string to an entity of type T
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="json"></param>
        /// <returns></returns>
        public static T ConvertFromJson<T>(string json)
        {
            var serializer = new System.Web.Script.Serialization.JavaScriptSerializer();
            return serializer.Deserialize<T>(json);
        }

        /// <summary>
        /// converts the supplied json string to an entity of the defined type 
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="json"></param>
        /// <returns></returns>
        public static object ConvertFromJson(string json, Type type)
        {
            var serializer = new System.Web.Script.Serialization.JavaScriptSerializer();
            return serializer.Deserialize(json, type);
        }

        
    }

  
}
